<?php

namespace App|C\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFlightStatusSummary ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfFlightStatusSummary
 * @subpackage Arrays
 */
class ArrayOfFlightStatusSummary extends AbstractStructArrayBase
{
    /**
     * The FlightStatusSummary
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FlightStatusSummary[]
     */
    public $FlightStatusSummary;
    /**
     * Constructor method for ArrayOfFlightStatusSummary
     * @uses ArrayOfFlightStatusSummary::setFlightStatusSummary()
     * @param \App|C\StructType\FlightStatusSummary[] $flightStatusSummary
     */
    public function __construct(array $flightStatusSummary = array())
    {
        $this
            ->setFlightStatusSummary($flightStatusSummary);
    }
    /**
     * Get FlightStatusSummary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FlightStatusSummary[]|null
     */
    public function getFlightStatusSummary()
    {
        return isset($this->FlightStatusSummary) ? $this->FlightStatusSummary : null;
    }
    /**
     * This method is responsible for validating the values passed to the setFlightStatusSummary method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFlightStatusSummary method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFlightStatusSummaryForArrayConstraintsFromSetFlightStatusSummary(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFlightStatusSummaryFlightStatusSummaryItem) {
            // validation for constraint: itemType
            if (!$arrayOfFlightStatusSummaryFlightStatusSummaryItem instanceof \App|C\StructType\FlightStatusSummary) {
                $invalidValues[] = is_object($arrayOfFlightStatusSummaryFlightStatusSummaryItem) ? get_class($arrayOfFlightStatusSummaryFlightStatusSummaryItem) : sprintf('%s(%s)', gettype($arrayOfFlightStatusSummaryFlightStatusSummaryItem), var_export($arrayOfFlightStatusSummaryFlightStatusSummaryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FlightStatusSummary property can only contain items of type \App|C\StructType\FlightStatusSummary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FlightStatusSummary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FlightStatusSummary[] $flightStatusSummary
     * @return \App|C\ArrayType\ArrayOfFlightStatusSummary
     */
    public function setFlightStatusSummary(array $flightStatusSummary = array())
    {
        // validation for constraint: array
        if ('' !== ($flightStatusSummaryArrayErrorMessage = self::validateFlightStatusSummaryForArrayConstraintsFromSetFlightStatusSummary($flightStatusSummary))) {
            throw new \InvalidArgumentException($flightStatusSummaryArrayErrorMessage, __LINE__);
        }
        if (is_null($flightStatusSummary) || (is_array($flightStatusSummary) && empty($flightStatusSummary))) {
            unset($this->FlightStatusSummary);
        } else {
            $this->FlightStatusSummary = $flightStatusSummary;
        }
        return $this;
    }
    /**
     * Add item to FlightStatusSummary value
     * @throws \InvalidArgumentException
     * @param \App|C\StructType\FlightStatusSummary $item
     * @return \App|C\ArrayType\ArrayOfFlightStatusSummary
     */
    public function addToFlightStatusSummary(\App|C\StructType\FlightStatusSummary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App|C\StructType\FlightStatusSummary) {
            throw new \InvalidArgumentException(sprintf('The FlightStatusSummary property can only contain items of type \App|C\StructType\FlightStatusSummary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FlightStatusSummary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \App|C\StructType\FlightStatusSummary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \App|C\StructType\FlightStatusSummary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \App|C\StructType\FlightStatusSummary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \App|C\StructType\FlightStatusSummary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \App|C\StructType\FlightStatusSummary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FlightStatusSummary
     */
    public function getAttributeName()
    {
        return 'FlightStatusSummary';
    }
}
