<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FareDisplayBaseSettings StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FareDisplayBaseSettings
 * @subpackage Structs
 */
class FareDisplayBaseSettings extends ApiObject
{
    /**
     * The ECouponBookCodes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfECouponBookCode
     */
    public $ECouponBookCodes;
    /**
     * The FareLevels
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfFareLevelRange
     */
    public $FareLevels;
    /**
     * The FareVisibilityCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FareVisibilityCode;
    /**
     * The FarebasisCodes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfstring_1
     */
    public $FarebasisCodes;
    /**
     * The ManualCombination
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $ManualCombination;
    /**
     * The PromoCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PromoCode;
    /**
     * The ShowWebClasses
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $ShowWebClasses;
    /**
     * The WebClassesCodes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\ArrayType\ArrayOfstring_1
     */
    public $WebClassesCodes;
    /**
     * Constructor method for FareDisplayBaseSettings
     * @uses FareDisplayBaseSettings::setECouponBookCodes()
     * @uses FareDisplayBaseSettings::setFareLevels()
     * @uses FareDisplayBaseSettings::setFareVisibilityCode()
     * @uses FareDisplayBaseSettings::setFarebasisCodes()
     * @uses FareDisplayBaseSettings::setManualCombination()
     * @uses FareDisplayBaseSettings::setPromoCode()
     * @uses FareDisplayBaseSettings::setShowWebClasses()
     * @uses FareDisplayBaseSettings::setWebClassesCodes()
     * @param \App|C\ArrayType\ArrayOfECouponBookCode $eCouponBookCodes
     * @param \App|C\ArrayType\ArrayOfFareLevelRange $fareLevels
     * @param string $fareVisibilityCode
     * @param \App|C\ArrayType\ArrayOfstring_1 $farebasisCodes
     * @param bool $manualCombination
     * @param string $promoCode
     * @param bool $showWebClasses
     * @param \App|C\ArrayType\ArrayOfstring_1 $webClassesCodes
     */
    public function __construct(\App|C\ArrayType\ArrayOfECouponBookCode $eCouponBookCodes = null, \App|C\ArrayType\ArrayOfFareLevelRange $fareLevels = null, $fareVisibilityCode = null, \App|C\ArrayType\ArrayOfstring_1 $farebasisCodes = null, $manualCombination = null, $promoCode = null, $showWebClasses = null, \App|C\ArrayType\ArrayOfstring_1 $webClassesCodes = null)
    {
        $this
            ->setECouponBookCodes($eCouponBookCodes)
            ->setFareLevels($fareLevels)
            ->setFareVisibilityCode($fareVisibilityCode)
            ->setFarebasisCodes($farebasisCodes)
            ->setManualCombination($manualCombination)
            ->setPromoCode($promoCode)
            ->setShowWebClasses($showWebClasses)
            ->setWebClassesCodes($webClassesCodes);
    }
    /**
     * Get ECouponBookCodes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfECouponBookCode|null
     */
    public function getECouponBookCodes()
    {
        return isset($this->ECouponBookCodes) ? $this->ECouponBookCodes : null;
    }
    /**
     * Set ECouponBookCodes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfECouponBookCode $eCouponBookCodes
     * @return \App|C\StructType\FareDisplayBaseSettings
     */
    public function setECouponBookCodes(\App|C\ArrayType\ArrayOfECouponBookCode $eCouponBookCodes = null)
    {
        if (is_null($eCouponBookCodes) || (is_array($eCouponBookCodes) && empty($eCouponBookCodes))) {
            unset($this->ECouponBookCodes);
        } else {
            $this->ECouponBookCodes = $eCouponBookCodes;
        }
        return $this;
    }
    /**
     * Get FareLevels value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfFareLevelRange|null
     */
    public function getFareLevels()
    {
        return isset($this->FareLevels) ? $this->FareLevels : null;
    }
    /**
     * Set FareLevels value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfFareLevelRange $fareLevels
     * @return \App|C\StructType\FareDisplayBaseSettings
     */
    public function setFareLevels(\App|C\ArrayType\ArrayOfFareLevelRange $fareLevels = null)
    {
        if (is_null($fareLevels) || (is_array($fareLevels) && empty($fareLevels))) {
            unset($this->FareLevels);
        } else {
            $this->FareLevels = $fareLevels;
        }
        return $this;
    }
    /**
     * Get FareVisibilityCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFareVisibilityCode()
    {
        return isset($this->FareVisibilityCode) ? $this->FareVisibilityCode : null;
    }
    /**
     * Set FareVisibilityCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $fareVisibilityCode
     * @return \App|C\StructType\FareDisplayBaseSettings
     */
    public function setFareVisibilityCode($fareVisibilityCode = null)
    {
        // validation for constraint: string
        if (!is_null($fareVisibilityCode) && !is_string($fareVisibilityCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fareVisibilityCode, true), gettype($fareVisibilityCode)), __LINE__);
        }
        if (is_null($fareVisibilityCode) || (is_array($fareVisibilityCode) && empty($fareVisibilityCode))) {
            unset($this->FareVisibilityCode);
        } else {
            $this->FareVisibilityCode = $fareVisibilityCode;
        }
        return $this;
    }
    /**
     * Get FarebasisCodes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfstring_1|null
     */
    public function getFarebasisCodes()
    {
        return isset($this->FarebasisCodes) ? $this->FarebasisCodes : null;
    }
    /**
     * Set FarebasisCodes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfstring_1 $farebasisCodes
     * @return \App|C\StructType\FareDisplayBaseSettings
     */
    public function setFarebasisCodes(\App|C\ArrayType\ArrayOfstring_1 $farebasisCodes = null)
    {
        if (is_null($farebasisCodes) || (is_array($farebasisCodes) && empty($farebasisCodes))) {
            unset($this->FarebasisCodes);
        } else {
            $this->FarebasisCodes = $farebasisCodes;
        }
        return $this;
    }
    /**
     * Get ManualCombination value
     * @return bool|null
     */
    public function getManualCombination()
    {
        return $this->ManualCombination;
    }
    /**
     * Set ManualCombination value
     * @param bool $manualCombination
     * @return \App|C\StructType\FareDisplayBaseSettings
     */
    public function setManualCombination($manualCombination = null)
    {
        // validation for constraint: boolean
        if (!is_null($manualCombination) && !is_bool($manualCombination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($manualCombination, true), gettype($manualCombination)), __LINE__);
        }
        $this->ManualCombination = $manualCombination;
        return $this;
    }
    /**
     * Get PromoCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPromoCode()
    {
        return isset($this->PromoCode) ? $this->PromoCode : null;
    }
    /**
     * Set PromoCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $promoCode
     * @return \App|C\StructType\FareDisplayBaseSettings
     */
    public function setPromoCode($promoCode = null)
    {
        // validation for constraint: string
        if (!is_null($promoCode) && !is_string($promoCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($promoCode, true), gettype($promoCode)), __LINE__);
        }
        if (is_null($promoCode) || (is_array($promoCode) && empty($promoCode))) {
            unset($this->PromoCode);
        } else {
            $this->PromoCode = $promoCode;
        }
        return $this;
    }
    /**
     * Get ShowWebClasses value
     * @return bool|null
     */
    public function getShowWebClasses()
    {
        return $this->ShowWebClasses;
    }
    /**
     * Set ShowWebClasses value
     * @param bool $showWebClasses
     * @return \App|C\StructType\FareDisplayBaseSettings
     */
    public function setShowWebClasses($showWebClasses = null)
    {
        // validation for constraint: boolean
        if (!is_null($showWebClasses) && !is_bool($showWebClasses)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($showWebClasses, true), gettype($showWebClasses)), __LINE__);
        }
        $this->ShowWebClasses = $showWebClasses;
        return $this;
    }
    /**
     * Get WebClassesCodes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\ArrayType\ArrayOfstring_1|null
     */
    public function getWebClassesCodes()
    {
        return isset($this->WebClassesCodes) ? $this->WebClassesCodes : null;
    }
    /**
     * Set WebClassesCodes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\ArrayType\ArrayOfstring_1 $webClassesCodes
     * @return \App|C\StructType\FareDisplayBaseSettings
     */
    public function setWebClassesCodes(\App|C\ArrayType\ArrayOfstring_1 $webClassesCodes = null)
    {
        if (is_null($webClassesCodes) || (is_array($webClassesCodes) && empty($webClassesCodes))) {
            unset($this->WebClassesCodes);
        } else {
            $this->WebClassesCodes = $webClassesCodes;
        }
        return $this;
    }
}
