<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FlightStatusSummary StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:FlightStatusSummary
 * @subpackage Structs
 */
class FlightStatusSummary extends AbstractStructBase
{
    /**
     * The AirportFlightStatusCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AirportFlightStatusCode;
    /**
     * The CityPair
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\CityPair
     */
    public $CityPair;
    /**
     * The EstimatedArrivalTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $EstimatedArrivalTime;
    /**
     * The FlightNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FlightNumber;
    /**
     * The RealArrivalTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RealArrivalTime;
    /**
     * The RealDepartureTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $RealDepartureTime;
    /**
     * The ScheduledArrivalTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ScheduledArrivalTime;
    /**
     * The ScheduledDepartureTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ScheduledDepartureTime;
    /**
     * Constructor method for FlightStatusSummary
     * @uses FlightStatusSummary::setAirportFlightStatusCode()
     * @uses FlightStatusSummary::setCityPair()
     * @uses FlightStatusSummary::setEstimatedArrivalTime()
     * @uses FlightStatusSummary::setFlightNumber()
     * @uses FlightStatusSummary::setRealArrivalTime()
     * @uses FlightStatusSummary::setRealDepartureTime()
     * @uses FlightStatusSummary::setScheduledArrivalTime()
     * @uses FlightStatusSummary::setScheduledDepartureTime()
     * @param string $airportFlightStatusCode
     * @param \App|C\StructType\CityPair $cityPair
     * @param string $estimatedArrivalTime
     * @param string $flightNumber
     * @param string $realArrivalTime
     * @param string $realDepartureTime
     * @param string $scheduledArrivalTime
     * @param string $scheduledDepartureTime
     */
    public function __construct($airportFlightStatusCode = null, \App|C\StructType\CityPair $cityPair = null, $estimatedArrivalTime = null, $flightNumber = null, $realArrivalTime = null, $realDepartureTime = null, $scheduledArrivalTime = null, $scheduledDepartureTime = null)
    {
        $this
            ->setAirportFlightStatusCode($airportFlightStatusCode)
            ->setCityPair($cityPair)
            ->setEstimatedArrivalTime($estimatedArrivalTime)
            ->setFlightNumber($flightNumber)
            ->setRealArrivalTime($realArrivalTime)
            ->setRealDepartureTime($realDepartureTime)
            ->setScheduledArrivalTime($scheduledArrivalTime)
            ->setScheduledDepartureTime($scheduledDepartureTime);
    }
    /**
     * Get AirportFlightStatusCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAirportFlightStatusCode()
    {
        return isset($this->AirportFlightStatusCode) ? $this->AirportFlightStatusCode : null;
    }
    /**
     * Set AirportFlightStatusCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $airportFlightStatusCode
     * @return \App|C\StructType\FlightStatusSummary
     */
    public function setAirportFlightStatusCode($airportFlightStatusCode = null)
    {
        // validation for constraint: string
        if (!is_null($airportFlightStatusCode) && !is_string($airportFlightStatusCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($airportFlightStatusCode, true), gettype($airportFlightStatusCode)), __LINE__);
        }
        if (is_null($airportFlightStatusCode) || (is_array($airportFlightStatusCode) && empty($airportFlightStatusCode))) {
            unset($this->AirportFlightStatusCode);
        } else {
            $this->AirportFlightStatusCode = $airportFlightStatusCode;
        }
        return $this;
    }
    /**
     * Get CityPair value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\CityPair|null
     */
    public function getCityPair()
    {
        return isset($this->CityPair) ? $this->CityPair : null;
    }
    /**
     * Set CityPair value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\CityPair $cityPair
     * @return \App|C\StructType\FlightStatusSummary
     */
    public function setCityPair(\App|C\StructType\CityPair $cityPair = null)
    {
        if (is_null($cityPair) || (is_array($cityPair) && empty($cityPair))) {
            unset($this->CityPair);
        } else {
            $this->CityPair = $cityPair;
        }
        return $this;
    }
    /**
     * Get EstimatedArrivalTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEstimatedArrivalTime()
    {
        return isset($this->EstimatedArrivalTime) ? $this->EstimatedArrivalTime : null;
    }
    /**
     * Set EstimatedArrivalTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $estimatedArrivalTime
     * @return \App|C\StructType\FlightStatusSummary
     */
    public function setEstimatedArrivalTime($estimatedArrivalTime = null)
    {
        // validation for constraint: string
        if (!is_null($estimatedArrivalTime) && !is_string($estimatedArrivalTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($estimatedArrivalTime, true), gettype($estimatedArrivalTime)), __LINE__);
        }
        if (is_null($estimatedArrivalTime) || (is_array($estimatedArrivalTime) && empty($estimatedArrivalTime))) {
            unset($this->EstimatedArrivalTime);
        } else {
            $this->EstimatedArrivalTime = $estimatedArrivalTime;
        }
        return $this;
    }
    /**
     * Get FlightNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFlightNumber()
    {
        return isset($this->FlightNumber) ? $this->FlightNumber : null;
    }
    /**
     * Set FlightNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $flightNumber
     * @return \App|C\StructType\FlightStatusSummary
     */
    public function setFlightNumber($flightNumber = null)
    {
        // validation for constraint: string
        if (!is_null($flightNumber) && !is_string($flightNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($flightNumber, true), gettype($flightNumber)), __LINE__);
        }
        if (is_null($flightNumber) || (is_array($flightNumber) && empty($flightNumber))) {
            unset($this->FlightNumber);
        } else {
            $this->FlightNumber = $flightNumber;
        }
        return $this;
    }
    /**
     * Get RealArrivalTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRealArrivalTime()
    {
        return isset($this->RealArrivalTime) ? $this->RealArrivalTime : null;
    }
    /**
     * Set RealArrivalTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $realArrivalTime
     * @return \App|C\StructType\FlightStatusSummary
     */
    public function setRealArrivalTime($realArrivalTime = null)
    {
        // validation for constraint: string
        if (!is_null($realArrivalTime) && !is_string($realArrivalTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($realArrivalTime, true), gettype($realArrivalTime)), __LINE__);
        }
        if (is_null($realArrivalTime) || (is_array($realArrivalTime) && empty($realArrivalTime))) {
            unset($this->RealArrivalTime);
        } else {
            $this->RealArrivalTime = $realArrivalTime;
        }
        return $this;
    }
    /**
     * Get RealDepartureTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getRealDepartureTime()
    {
        return isset($this->RealDepartureTime) ? $this->RealDepartureTime : null;
    }
    /**
     * Set RealDepartureTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $realDepartureTime
     * @return \App|C\StructType\FlightStatusSummary
     */
    public function setRealDepartureTime($realDepartureTime = null)
    {
        // validation for constraint: string
        if (!is_null($realDepartureTime) && !is_string($realDepartureTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($realDepartureTime, true), gettype($realDepartureTime)), __LINE__);
        }
        if (is_null($realDepartureTime) || (is_array($realDepartureTime) && empty($realDepartureTime))) {
            unset($this->RealDepartureTime);
        } else {
            $this->RealDepartureTime = $realDepartureTime;
        }
        return $this;
    }
    /**
     * Get ScheduledArrivalTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getScheduledArrivalTime()
    {
        return isset($this->ScheduledArrivalTime) ? $this->ScheduledArrivalTime : null;
    }
    /**
     * Set ScheduledArrivalTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $scheduledArrivalTime
     * @return \App|C\StructType\FlightStatusSummary
     */
    public function setScheduledArrivalTime($scheduledArrivalTime = null)
    {
        // validation for constraint: string
        if (!is_null($scheduledArrivalTime) && !is_string($scheduledArrivalTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($scheduledArrivalTime, true), gettype($scheduledArrivalTime)), __LINE__);
        }
        if (is_null($scheduledArrivalTime) || (is_array($scheduledArrivalTime) && empty($scheduledArrivalTime))) {
            unset($this->ScheduledArrivalTime);
        } else {
            $this->ScheduledArrivalTime = $scheduledArrivalTime;
        }
        return $this;
    }
    /**
     * Get ScheduledDepartureTime value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getScheduledDepartureTime()
    {
        return isset($this->ScheduledDepartureTime) ? $this->ScheduledDepartureTime : null;
    }
    /**
     * Set ScheduledDepartureTime value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $scheduledDepartureTime
     * @return \App|C\StructType\FlightStatusSummary
     */
    public function setScheduledDepartureTime($scheduledDepartureTime = null)
    {
        // validation for constraint: string
        if (!is_null($scheduledDepartureTime) && !is_string($scheduledDepartureTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($scheduledDepartureTime, true), gettype($scheduledDepartureTime)), __LINE__);
        }
        if (is_null($scheduledDepartureTime) || (is_array($scheduledDepartureTime) && empty($scheduledDepartureTime))) {
            unset($this->ScheduledDepartureTime);
        } else {
            $this->ScheduledDepartureTime = $scheduledDepartureTime;
        }
        return $this;
    }
}
